package cn.com.ctop.kuaishou.modules.batch.controller;

import cn.com.ctop.common.module.utils.Check;
import cn.com.ctop.kuaishou.modules.batch.entity.KuaiShouBatchGroupTemplate;
import cn.com.ctop.kuaishou.modules.batch.service.IKuaiShouBatchGroupTemplateService;
import com.alibaba.fastjson.JSON;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import lombok.extern.slf4j.Slf4j;
import org.jeecg.common.api.vo.Result;
import org.jeecg.common.aspect.annotation.AutoLog;
import org.jeecg.common.system.query.QueryGenerator;
import org.jeecg.common.util.oConvertUtils;
import org.jeecgframework.poi.excel.ExcelImportUtil;
import org.jeecgframework.poi.excel.def.NormalExcelConstants;
import org.jeecgframework.poi.excel.entity.ExportParams;
import org.jeecgframework.poi.excel.entity.ImportParams;
import org.jeecgframework.poi.excel.view.JeecgEntityExcelView;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;
import org.springframework.web.multipart.MultipartHttpServletRequest;
import org.springframework.web.servlet.ModelAndView;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.io.IOException;
import java.io.UnsupportedEncodingException;
import java.net.URLDecoder;
import java.util.Arrays;
import java.util.List;
import java.util.Map;

/**
 * 创意模板
 *
 * @author jeecg-boot
 * @version V1.0
 * @date 2021-01-19
 */
@Slf4j
@Api(tags = "创意模板")
@RestController
@RequestMapping("/template/kuaiShouBatchGroupTemplate")
public class KuaiShouBatchGroupTemplateController {
    @Autowired
    private IKuaiShouBatchGroupTemplateService kuaiShouBatchGroupTemplateService;

    /**
     * 分页列表查询
     *
     * @param kuaiShouBatchGroupTemplate
     * @param pageNo
     * @param pageSize
     * @param req
     * @return
     */
    @AutoLog(value = "创意模板-分页列表查询")
    @ApiOperation(value = "创意模板-分页列表查询", notes = "创意模板-分页列表查询")
    @GetMapping(value = "/list")
    public Result<IPage<KuaiShouBatchGroupTemplate>> queryPageList(KuaiShouBatchGroupTemplate kuaiShouBatchGroupTemplate,
                                                                   @RequestParam(name = "pageNo", defaultValue = "1") Integer pageNo,
                                                                   @RequestParam(name = "pageSize", defaultValue = "10") Integer pageSize,
                                                                   HttpServletRequest req) {
        Result<IPage<KuaiShouBatchGroupTemplate>> result = new Result<>();
        QueryWrapper<KuaiShouBatchGroupTemplate> queryWrapper = QueryGenerator.initQueryWrapper(kuaiShouBatchGroupTemplate, req.getParameterMap());
        Page<KuaiShouBatchGroupTemplate> page = new Page<KuaiShouBatchGroupTemplate>(pageNo, pageSize);
        IPage<KuaiShouBatchGroupTemplate> pageList = kuaiShouBatchGroupTemplateService.page(page, queryWrapper);
        result.setSuccess(true);
        result.setResult(pageList);
        return result;
    }

    @AutoLog(value = "查询广告组预设模板")
    @ApiOperation(value = "查询广告组预设模板", notes = "查询广告组预设模板")
    @GetMapping(value = "/getGroupTemplate")
    public Result<KuaiShouBatchGroupTemplate> getGroupTemplate(Long accountId) {
        Result<KuaiShouBatchGroupTemplate> result = new Result<>();
        QueryWrapper<KuaiShouBatchGroupTemplate> queryWrapper = new QueryWrapper<>();
        queryWrapper.eq("account_id", accountId);
        queryWrapper.orderByDesc("create_time");
        queryWrapper.last("limit 1");
        KuaiShouBatchGroupTemplate one = kuaiShouBatchGroupTemplateService.getOne(queryWrapper);
        result.setSuccess(true);
        result.setResult(one);
        return result;
    }

    @AutoLog(value = "创建广告组预设模板")
    @ApiOperation(value = "创建广告组预设模板", notes = "创建广告组预设模板")
    @PostMapping(value = "/saveOrUpdate")
    public Result<Object> saveOrUpdate(@RequestBody KuaiShouBatchGroupTemplate kuaiShouBatchGroupTemplate) {
        boolean ok;
        try {
            Long id = kuaiShouBatchGroupTemplate.getId();
            if (Check.isNull(id)) {
                ok = kuaiShouBatchGroupTemplateService.save(kuaiShouBatchGroupTemplate);
            } else {
                KuaiShouBatchGroupTemplate kuaiShouBatchCampaignTemplateEntity = kuaiShouBatchGroupTemplateService.getById(id);
                if (!Check.isNull(kuaiShouBatchCampaignTemplateEntity)) {
                    ok = kuaiShouBatchGroupTemplateService.updateById(kuaiShouBatchGroupTemplate);
                } else {
                    throw new Exception("未获取到账户id对应的详细信息");
                }
            }
            if (ok) {
                return Result.ok(kuaiShouBatchGroupTemplate.getId());
            }
            return Result.error("操作失败");
        } catch (Exception e) {
            return Result.error(e.getMessage());
        }
    }

    /**
     * 添加
     *
     * @param kuaiShouBatchGroupTemplate
     * @return
     */
    @AutoLog(value = "创意模板-添加")
    @ApiOperation(value = "创意模板-添加", notes = "创意模板-添加")
    @PostMapping(value = "/add")
    public Result<KuaiShouBatchGroupTemplate> add(@RequestBody KuaiShouBatchGroupTemplate kuaiShouBatchGroupTemplate) {
        Result<KuaiShouBatchGroupTemplate> result = new Result<>();
        try {
            kuaiShouBatchGroupTemplateService.save(kuaiShouBatchGroupTemplate);
            result.success("添加成功！");
        } catch (Exception e) {
            log.error(e.getMessage(), e);
            result.error500("操作失败");
        }
        return result;
    }

    /**
     * 编辑
     *
     * @param kuaiShouBatchGroupTemplate
     * @return
     */
    @AutoLog(value = "创意模板-编辑")
    @ApiOperation(value = "创意模板-编辑", notes = "创意模板-编辑")
    @PutMapping(value = "/edit")
    public Result<KuaiShouBatchGroupTemplate> edit(@RequestBody KuaiShouBatchGroupTemplate kuaiShouBatchGroupTemplate) {
        Result<KuaiShouBatchGroupTemplate> result = new Result<KuaiShouBatchGroupTemplate>();
        KuaiShouBatchGroupTemplate kuaiShouBatchGroupTemplateEntity = kuaiShouBatchGroupTemplateService.getById(kuaiShouBatchGroupTemplate.getId());
        if (kuaiShouBatchGroupTemplateEntity == null) {
            result.error500("未找到对应实体");
        } else {
            boolean ok = kuaiShouBatchGroupTemplateService.updateById(kuaiShouBatchGroupTemplate);
            if (ok) {
                result.success("修改成功!");
            }
        }

        return result;
    }

    /**
     * 通过id删除
     *
     * @param id
     * @return
     */
    @AutoLog(value = "创意模板-通过id删除")
    @ApiOperation(value = "创意模板-通过id删除", notes = "创意模板-通过id删除")
    @DeleteMapping(value = "/delete")
    public Result<?> delete(@RequestParam(name = "id", required = true) String id) {
        try {
            kuaiShouBatchGroupTemplateService.removeById(id);
        } catch (Exception e) {
            log.error("删除失败", e.getMessage());
            return Result.error("删除失败!");
        }
        return Result.ok("删除成功!");
    }

    /**
     * 批量删除
     *
     * @param ids
     * @return
     */
    @AutoLog(value = "创意模板-批量删除")
    @ApiOperation(value = "创意模板-批量删除", notes = "创意模板-批量删除")
    @DeleteMapping(value = "/deleteBatch")
    public Result<KuaiShouBatchGroupTemplate> deleteBatch(@RequestParam(name = "ids", required = true) String ids) {
        Result<KuaiShouBatchGroupTemplate> result = new Result<>();
        if (ids == null || "".equals(ids.trim())) {
            result.error500("参数不识别！");
        } else {
            this.kuaiShouBatchGroupTemplateService.removeByIds(Arrays.asList(ids.split(",")));
            result.success("删除成功!");
        }
        return result;
    }

    /**
     * 通过id查询
     *
     * @param id
     * @return
     */
    @AutoLog(value = "创意模板-通过id查询")
    @ApiOperation(value = "创意模板-通过id查询", notes = "创意模板-通过id查询")
    @GetMapping(value = "/queryById")
    public Result<KuaiShouBatchGroupTemplate> queryById(@RequestParam(name = "id", required = true) String id) {
        Result<KuaiShouBatchGroupTemplate> result = new Result<>();
        KuaiShouBatchGroupTemplate kuaiShouBatchGroupTemplate = kuaiShouBatchGroupTemplateService.getById(id);
        if (kuaiShouBatchGroupTemplate == null) {
            result.error500("未找到对应实体");
        } else {
            result.setResult(kuaiShouBatchGroupTemplate);
            result.setSuccess(true);
        }
        return result;
    }

    /**
     * 导出excel
     *
     * @param request
     * @param response
     */
    @RequestMapping(value = "/exportXls")
    public ModelAndView exportXls(HttpServletRequest request, HttpServletResponse response) {
        // Step.1 组装查询条件
        QueryWrapper<KuaiShouBatchGroupTemplate> queryWrapper = null;
        try {
            String paramsStr = request.getParameter("paramsStr");
            if (oConvertUtils.isNotEmpty(paramsStr)) {
                String deString = URLDecoder.decode(paramsStr, "UTF-8");
                KuaiShouBatchGroupTemplate kuaiShouBatchGroupTemplate = JSON.parseObject(deString, KuaiShouBatchGroupTemplate.class);
                queryWrapper = QueryGenerator.initQueryWrapper(kuaiShouBatchGroupTemplate, request.getParameterMap());
            }
        } catch (UnsupportedEncodingException e) {
            e.printStackTrace();
        }

        //Step.2 AutoPoi 导出Excel
        ModelAndView mv = new ModelAndView(new JeecgEntityExcelView());
        List<KuaiShouBatchGroupTemplate> pageList = kuaiShouBatchGroupTemplateService.list(queryWrapper);
        //导出文件名称
        mv.addObject(NormalExcelConstants.FILE_NAME, "创意模板列表");
        mv.addObject(NormalExcelConstants.CLASS, KuaiShouBatchGroupTemplate.class);
        mv.addObject(NormalExcelConstants.PARAMS, new ExportParams("创意模板列表数据", "导出人:Jeecg", "导出信息"));
        mv.addObject(NormalExcelConstants.DATA_LIST, pageList);
        return mv;
    }

    /**
     * 通过excel导入数据
     *
     * @param request
     * @param response
     * @return
     */
    @RequestMapping(value = "/importExcel", method = RequestMethod.POST)
    public Result<?> importExcel(HttpServletRequest request, HttpServletResponse response) {
        MultipartHttpServletRequest multipartRequest = (MultipartHttpServletRequest) request;
        Map<String, MultipartFile> fileMap = multipartRequest.getFileMap();
        for (Map.Entry<String, MultipartFile> entity : fileMap.entrySet()) {
            MultipartFile file = entity.getValue();
            ImportParams params = new ImportParams();
            params.setTitleRows(2);
            params.setHeadRows(1);
            params.setNeedSave(true);
            try {
                List<KuaiShouBatchGroupTemplate> listKuaiShouBatchGroupTemplates = ExcelImportUtil.importExcel(file.getInputStream(), KuaiShouBatchGroupTemplate.class, params);
                kuaiShouBatchGroupTemplateService.saveBatch(listKuaiShouBatchGroupTemplates);
                return Result.ok("文件导入成功！数据行数:" + listKuaiShouBatchGroupTemplates.size());
            } catch (Exception e) {
                log.error(e.getMessage(), e);
                return Result.error("文件导入失败:" + e.getMessage());
            } finally {
                try {
                    file.getInputStream().close();
                } catch (IOException e) {
                    e.printStackTrace();
                }
            }
        }
        return Result.ok("文件导入失败！");
    }

}
